<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet
   xmlns:xsl="http://www.w3.org/TR/WD-xsl"
   xmlns="http://www.w3.org/TR/REC-html40">

<xsl:template match="*">
   <xsl:apply-templates/>
</xsl:template>

<xsl:template match="text()">
   <xsl:value-of select="."/>
</xsl:template>

<xsl:template match="/">
   <HTML>
   <HEAD>
      <TITLE>Pineapplesoft Link</TITLE>
   </HEAD>
   <BODY>
      <xsl:apply-templates/>
   </BODY>
   </HTML>
</xsl:template>

<xsl:template match="section/title">
   <P><I><xsl:apply-templates/></I></P>
</xsl:template>

<xsl:template match="article/title">
   <P><B><xsl:apply-templates/></B></P>
</xsl:template>

<xsl:template match="url">
   <A TARGET="_blank">
      <xsl:attribute name="href">
         <xsl:apply-templates/>
      </xsl:attribute>
      <xsl:apply-templates/>
   </A>
</xsl:template>

<xsl:template match="url[@protocol='mailto']">
   <A>
      <xsl:attribute name="href">mailto:<xsl:apply-templates/>
      </xsl:attribute>
      <xsl:apply-templates/>
   </A>
</xsl:template>

<xsl:template match="p">
   <P><xsl:apply-templates/></P>
</xsl:template>

<xsl:template match="abstract | date | keywords | copyright"/>

</xsl:stylesheet>