function convert(form,xmldocument)
{
   var fname = form.fname.value,
       output = form.output,
       rate = form.rate.value;

   output.value = "";

   var document = parse(fname,xmldocument),
       topLevel = document.documentElement;
   walkNode(topLevel,document,rate);

   addHeader(document,rate);

   output.value = document.xml;
}

function parse(uri,xmldocument)
{
   xmldocument.async = false;
   xmldocument.load(uri);
   
   if(xmldocument.parseError.errorCode != 0)
      alert(xmldocument.parseError.reason);

   return xmldocument;
}

function walkNode(node,document,rate)
{
   if(node.nodeType == 1)
   {
      if(node.nodeName == "product")
        walkProduct(node,document,rate);
      else
      {
         var children,
             i;
         children = node.childNodes;
         for(i = 0;i < children.length;i++)
            walkNode(children.item(i),document,rate);
      }
   }
}

function walkProduct(node,document,rate)
{
   if(node.nodeType == 1 && node.nodeName == "product")
   {     
      var price,
          children,
          i;
      children = node.childNodes;
      for(i = 0;i < children.length;i++)
      {
         var child = children.item(i);
	  if(child.nodeType == 1)
            if(child.nodeName == "price")
               price = child;
      }
      // append the new child after looping to avoid infinite loop
      var element = document.createElement("price"),
          text = document.createTextNode(getText(price) * rate);
      element.setAttribute("currency","eur");
	  element.appendChild(text);
      node.appendChild(element);
	  price.setAttribute("currency","usd");
   }
}

function addHeader(document,rate)
{
   var comment = document.createComment(
                    "Rate used for this conversion: " + rate),
       stylesheet = document.createProcessingInstruction(
                      "xml-stylesheet",
                      "href=\"prices.css\" type=\"text/css\""),
       topLevel = document.documentElement;
   document.insertBefore(comment,topLevel);
   document.insertBefore(stylesheet,comment);
}

function getText(node)
{
   return node.firstChild.data;
}