var products = new Array();

function addProduct(form)
{
   // collects data from the form
   var name = form.name.value,
       dollars = form.dollarsamount.value,
       euros = form.eurosamount.value,
       productList = form.productlist;

   // creates the various objects required
   var dollarsPrice = new Price(dollars,"usd"),
       eurosPrice = new Price(euros,"eur"),
       prices = new Array(dollarsPrice,eurosPrice),
       product = new Product(name,prices);

   // arrays are zero-based so products.length points
   // to one past the latest product
   // JavaScript automatically allocates memory
   var pos = products.length;
   products[pos] = product;

   var option = new Option(name,pos);

   productList.options[productList.length] = option;
}

function deleteProduct(form)
{
   var productList = form.productlist,
       pos = productList.selectedIndex;

   if(pos != -1)
   {
      var product = productList.options[pos].value;
      productList.options[pos] = null;
      products[product] = null;
   }
}

function exportProduct(form)
{
   form.output.value = makeXML();
}

function send()
{
   var http = new ActiveXObject("Microsoft.XMLHTTP");
   http.open("POST","http://catwoman.pineapplesoft.com/Dump",false);
   http.setRequestHeader("Content-type","application/xml");
   http.send("value=" + makeXML());
   document.open();
   document.write(http.responseText);
}

function makeXML()
{
   var xmlCode = "";

   var i;
   for(i = 0;i < products.length;i++)
      if(products[i] != null)
         xmlCode += products[i].toXML();

  return element("products","",xmlCode);
}

function resetAll(form,document)
{
   priceList = null;
   form.output.value = "";
}

function element(name,attributes,content)
{
   var result = "<" + name;
   if(attributes != "")
      result += " " + attributes;
   result += ">";
   result += content;
   result += "</" + name + ">\r";
   return result;
}

function escapeXML(string)
{
   var result = "",
       i,
       c;
   for(i = 0;i < string.length;i++)
   {
      c = string.charAt(i);
      if(c == '<')
         result += "&lt;";
      else if(c == '&')
         result += "&amp;";
      else
         result += c;
   }
   return result;
}

// declares two JavaScript objects

// product object

function Product(name,prices)
{
   this.name = name;
   this.prices = prices;
   this.toXML = product_toXML;
}

function product_toXML()
{
   var result = element("name","",escapeXML(this.name)),
       i;
   for(i = 0;i < this.prices.length;i++)
      result += this.prices[i].toXML();
   return element("product","",result);
}

// price object

function Price(amount,currency)
{
   this.amount = amount;
   this.currency = currency;
   this.toXML = price_toXML;
}

function price_toXML()
{
   return element("price",
                  "currency=\"" + this.currency + "\"",
                  escapeXML(this.amount));
}