// editor.js, common code for Editor

var products = new Array();

function addProduct(form)
{
   // collects data from the form
   var id = form.id.value,
       name = form.name1.value,
       price = form.price.value,
       description = form.description.value;

   doAddProduct(form,id,name,price,description);
}

function doAddProduct(form,id,name,price,description)
{
   var productList = form.productlist,
       product = new Product(id,name,price,description);

   // arrays are zero-based so products.length points
   // to one past the latest product
   // JavaScript automatically allocates memory
   var pos = products.length;
   products[pos] = product;

   var option = new Option(name + " (" + price + ")",pos);

   productList.options[productList.length] = option;
}

function deleteProduct(form)
{
   var productList = form.productlist,
       pos = productList.selectedIndex;

   if(pos != -1)
   {
      var product = productList.options[pos].value;
      productList.options[pos] = null;
      products[product] = null;
   }
}

function exportProduct(form)
{
   var xmlCode = "",
       merchant = form.merchant.value,
       attribute = "merchant='" + merchant + "'";

   var i;
   for(i = 0;i < products.length;i++)
      if(products[i] != null)
         xmlCode += products[i].toXML();

   xmlCode = element("products",attribute,xmlCode);

   form.xmldata.value = "<?xml version='1.0'?>" + xmlCode;
}

function resetAll(form,document)
{
   priceList = null;
   form.output.value = "";
}

function element(name,attributes,content)
{
   var result = "<" + name;
   if(attributes != "")
      result += " " + attributes;
   result += ">";
   result += content;
   result += "</" + name + ">\r";
   return result;
}

function escapeXML(string)
{
   var result = "",
       i,
       c;
   for(i = 0;i < string.length;i++)
   {
      c = string.charAt(i);
      if(c == '<')
         result += "&lt;";
      else if(c == '&')
         result += "&amp;";
      else
         result += c;
   }
   return result;
}

// declares product object

function Product(id,name,price,description)
{
   this.id = id;
   this.name = name;
   this.price = price;
   this.description = description;
   this.toXML = product_toXML;
}

function product_toXML()
{
   var attrs = "id='" + this.id + "'",
       result = element("name","",escapeXML(this.name));
   result += element("price","",escapeXML(this.price));
   result += element("description","",
                     escapeXML(this.description));
   return element("product",attrs,result);
}