package com.psol.lel;

import java.io.*;

/**
 * Rewrite a text file with system-specific end of lines.<BR>
 * Useful for text files downloaded from the Net.
 *
 * @author Benot Marchal
 * @version 28 August 1999
 */

public class LeL
{
   /**
    * Entry-point for the program.<BR>
    * Expect two filenames on the command-line: input and output.
    *
    * @param args command-line parameters
    */
   public static void main(String[] args)
   {
      if(args.length < 2)
         System.err.println("Usage is: java com.psol.lel.LeL input output");
      // we don't want to overwrite a file by mistake
      else if(new File(args[1]).exists())
         System.err.println("Error: output file already exists!");
      else
         try
         {
            BufferedReader reader =
               new BufferedReader(new FileReader(args[0]));
            PrintWriter writer =
               new PrintWriter(new FileWriter(args[1]));
            // the try/finally guarantees the writer is closed
            try
            {
               for(String line = reader.readLine();
                   null != line;
                   line = reader.readLine())
                  writer.println(line);
            }
            finally
            {
               writer.close();
            }
         }
         catch(IOException e)
         {
            System.err.println("Error: " + e.getMessage());
         }
   }
}